#! /usr/bin/env perl
#
#	Compile a single executable from a single .c file in the
#	local directory.  The .c file includes a single .h file
#	from a subdirectory, which in turn includes another .h file
#	from that subdirectory.  Update the second .h file and
#	re-compile.
#

# $Id: t0015.t,v 1.4 2000/09/10 05:01:27 knight Exp $

# Copyright (c) 1996-2000 Free Software Foundation, Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 02111-1307, USA.

use Test::Cmd::Cons;

$test = Test::Cmd::Cons->new(string => 'nested #include <...>');

$test->subdir('include', 'zark');

#
$test->write('Construct', <<_EOF_);
\%env_hash = ( ${\$test->cons_env} );
\$env_hash{CPPPATH} = '.';
\$env = new cons ( \%env_hash );
Program \$env 'foo', 'foo.c';
_EOF_

$test->write('foo.c', <<'_EOF_');
#include <include/foo.h>
int
main(int argc, char *argv[])
{
	printf(STRING);
	exit (0);
}
_EOF_

$test->write(['include', 'foo.h'], <<'_EOF_');
#include <include/bar.h>
_EOF_

$test->write(['include', 'bar.h'], <<'_EOF_');
#define	STRING	"include/bar.h\n"
_EOF_

#
$test->run(targets => ".");

$test->execute(prog => 'foo', stdout => <<'_EOF_');
include/bar.h
_EOF_

$test->write(['include', 'bar.h'], <<'_EOF_');
#define	STRING	"include/bar.h again\n"
_EOF_

#
$test->run(targets => ".");

$test->execute(prog => 'foo', stdout => <<'_EOF_');
include/bar.h again
_EOF_

#
$test->pass;
__END__
